// VCDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCDemo.h"
#include "VCDemoDlg.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVCDemoDlg dialog

CVCDemoDlg::CVCDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVCDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	init = FALSE;
	
	srand( (unsigned)time( NULL ) );
    for (int i=0;i<4;i++) {
        theta[i] = rand()/RAND_MAX * 3.14159;
        rates[i] = 0.2 * rand()/RAND_MAX;
		}

}

void CVCDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCDemoDlg)
	DDX_Control(pDX, IDC_DECAY1, DECAY1);
	DDX_Control(pDX, IDC_DECAY2, DECAY2);
	DDX_Control(pDX, IDC_DECAY3, DECAY3);
	DDX_Control(pDX, IDC_DECAY4, DECAY4);
	DDX_Control(pDX, IDC_LED1, LED1);
	DDX_Control(pDX, IDC_LED10, LED10);
	DDX_Control(pDX, IDC_LED11, LED11);
	DDX_Control(pDX, IDC_LED12, LED12);
	DDX_Control(pDX, IDC_LED2, LED2);
	DDX_Control(pDX, IDC_LED3, LED3);
	DDX_Control(pDX, IDC_LED4, LED4);
	DDX_Control(pDX, IDC_LED5, LED5);
	DDX_Control(pDX, IDC_LED6, LED6);
	DDX_Control(pDX, IDC_LED7, LED7);
	DDX_Control(pDX, IDC_LED8, LED8);
	DDX_Control(pDX, IDC_LED9, LED9);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CVCDemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCDemoDlg message handlers

BOOL CVCDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVCDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}

	if (!init) {
		init = 1;
		SetTimer(1000,150,NULL);
		SetTimer(1010,400,NULL);
		}

}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVCDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CVCDemoDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CVCDemoDlg)
	ON_EVENT(CVCDemoDlg, IDC_DECAY1, -601 /* DblClick */, OnDblClickDecay1, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_DECAY2, -601 /* DblClick */, OnDblClickDecay2, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_DECAY3, -601 /* DblClick */, OnDblClickDecay3, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_DECAY4, -601 /* DblClick */, OnDblClickDecay4, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_LED1, -601 /* DblClick */, OnDblClickLed1, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_LED1, 1 /* Change */, OnChangeLed1, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_LED10, -601 /* DblClick */, OnDblClickLed10, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_LED11, -601 /* DblClick */, OnDblClickLed11, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_LED12, -601 /* DblClick */, OnDblClickLed12, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_LED2, 1 /* Change */, OnChangeLed2, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_LED2, -601 /* DblClick */, OnDblClickLed2, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_LED3, -601 /* DblClick */, OnDblClickLed3, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_LED4, -601 /* DblClick */, OnDblClickLed4, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_LED5, -601 /* DblClick */, OnDblClickLed5, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_LED6, -601 /* DblClick */, OnDblClickLed6, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_LED7, -601 /* DblClick */, OnDblClickLed7, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_LED8, -601 /* DblClick */, OnDblClickLed8, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_LED9, -601 /* DblClick */, OnDblClickLed9, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

BOOL CVCDemoDlg::DestroyWindow() 
{
	KillTimer(1000);
	KillTimer(1010);
	
	return CDialog::DestroyWindow();
}

void CVCDemoDlg::OnTimer(UINT nIDEvent) 
{
int i;

	switch (nIDEvent) {
		case 1000: //fast timer
			DECAY1.SetValue((short) (32.0 * pow(sin(theta[0]),2.0)));
			DECAY2.SetValue((short) (32.0 * pow(sin(theta[1]),2.0)));
			DECAY3.SetValue((short) (32.0 * pow(sin(theta[2]),2.0)));
			DECAY4.SetValue((short) (32.0 * pow(sin(theta[3]),2.0)));
			
			for (i=0;i<4;i++) {
				theta[i] = theta[i] + rates[i];
				}
			
			break;
		case 1010: //slow timer
			LED12.SetValue((short) ((double) rand()/(double) RAND_MAX * 32767));
			LED9.SetValue((short) ((double) rand()/(double) RAND_MAX * 32767));

			break;
		}
	
	CDialog::OnTimer(nIDEvent);
}

void CVCDemoDlg::OnDblClickDecay1() 
{
	DECAY1.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickDecay2() 
{
	DECAY2.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickDecay3() 
{
	DECAY3.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickDecay4() 
{
	DECAY4.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickLed1() 
{
	LED1.ShowPropertyPage();
}

void CVCDemoDlg::OnChangeLed1() 
{
	LED2.SetValue(LED1.GetValue());
}

void CVCDemoDlg::OnDblClickLed10() 
{
	LED10.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickLed11() 
{
	LED11.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickLed12() 
{
	LED12.ShowPropertyPage();
}

void CVCDemoDlg::OnChangeLed2() 
{
	LED1.SetValue(LED2.GetValue());
}

void CVCDemoDlg::OnDblClickLed2() 
{
	LED2.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickLed3() 
{
	LED3.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickLed4() 
{
	LED4.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickLed5() 
{
	LED5.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickLed6() 
{
	LED6.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickLed7() 
{
	LED7.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickLed8() 
{
	LED8.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickLed9() 
{
	LED9.ShowPropertyPage();
}
